(*
Filename: Actions.v

Formalization of the type of system actions.

*)
Require Export BasicDefs.

Section Actions.

(*System calls *)
Parameter SACall : Set.

(*Actions*)
Inductive Action : Type :=
| install : App -> Action
| uninstall : App -> Action
| start : iCmp -> Cmp -> Action
| stop : iCmp -> Action
| call : iCmp -> SACall -> Action
| read : iCmp -> CProvider -> uri -> Action
| write : iCmp -> CProvider -> uri -> Val -> Action
| grantT : iCmp -> CProvider -> Activity -> uri -> PType -> Action
| grantP : iCmp -> CProvider -> App -> uri -> PType -> Action 
| revoke : iCmp -> CProvider -> uri -> PType -> Action.

End Actions.
