(*
Filename: Inv.v

Proof of valid state invariant. We prove auxiliary lemmas that show
the invariance of each valid state condition for each action.

*)
Require Import Tactics.

Require Import allAppDifferent.
Require Import allCmpDifferent.
Require Import cmpRunAppIns.
Require Import delTmpRun.
Require Import existsAppnCPinDel.
Require Import notCPrunning.
Require Import usrPermsDefined.
Require Import notRepeatedIns.
Require Import notRepeatedCmps.
Require Import resContAppInst.
Require Import resContOneVal.

Theorem invariance : forall (a:Action)(s s':State), exec s a s' -> validState s'. 
unfold validState.
intros a s s' H_exec.
inversion H_exec as [H_valid H_pre H_post].
destruct_valid_state H_valid.
split.
apply (allAppDifferentInv a s); assumption.
split.
apply (allCmpDifferentInv a s); assumption.
split.
apply (notRepeatedCmpsInv a s); assumption.
split.
apply (notCPrunningInv a s); assumption.
split.
apply (usrPermsDefinedInv a s); assumption.
split.
apply (existsAppnCPinDelInv a s); assumption.
split.
apply (delTmpRunInv a s); assumption.
split.
apply (cmpRunAppInsInv a s); assumption.
split.
apply (notRepeatedInsInv a s); assumption.
split.
apply (resContAppInstInv a s); assumption.
apply (resContOneValInv a s); assumption.
Qed.